#ifndef GA_CROSSOVER_H
#define GA_CROSSOVER_H 

#include<cmath>
#include<vector.h>
#include<iostream.h>
#include "./random_generators.h"
#include "./random_init.h"

using namespace std;

// ****************************************************************

vector<GA_Individual> crossover( const GA_Individual& parent1, 
                                 const GA_Individual& parent2 )
{ vector<GA_Individual> recombinants(2);
  recombinants[0] = parent1;
  recombinants[1] = parent2;
  vector<bool> geno_type1 = parent1.geno_type;
  vector<bool> geno_type2 = parent2.geno_type;
  size_t g_dim = geno_type1.size();
  size_t xo_pt;
  vector<bool> xo_mask(g_dim, 0);
//
// calculating the XO-mask
  xo_pt = uniCO.SampleDiscreteUnifMinMax(0, g_dim-2);
  for( size_t i = 0; i <= xo_pt; i++ ) xo_mask[i] = 1;
// doing the XO
  for( size_t i = 0; i < g_dim; i++ )
  { if( xo_mask[i] ) 
    { geno_type1[i] = parent2.geno_type[i];
      geno_type2[i] = parent1.geno_type[i];
    }
    else
    { geno_type1[i] = parent1.geno_type[i];
      geno_type2[i] = parent2.geno_type[i];
    } 
  }
  recombinants[0].geno_type = geno_type1;
  recombinants[1].geno_type = geno_type2;
//
  return recombinants;
}
 
// ****************************************************************
// ****************************************************************

#endif
