#ifndef GA_INDIVIDUAL_H
#define GA_INDIVIDUAL_H 

#include<cmath>
#include<vector.h>
#include<iostream.h>
#include "./random_generators.h"
#include "./random_init.h"
#include "./bit_string.h"

using namespace std;

// ****************************************************************

class GA_Individual 
{ 
  public:
    double fitness;
    double selection_probability;
    vector<double> pheno_type;
    vector<bool> geno_type;
    void gp_map();
    void evaluate();
    void mutate(double);
};

// ****************************************************************

void GA_Individual::evaluate()
{ double objective_function( const vector<double> & );
  fitness = objective_function(pheno_type);
}

// ****************************************************************

void GA_Individual::gp_map()
{ size_t g_dim = geno_type.size();
  size_t p_dim = pheno_type.size();
  size_t p_len = g_dim/p_dim;
  for( size_t i=0; i < p_dim; i++ )
    pheno_type[i] = (double) B_to_I(geno_type, i*p_len, p_len);
}

// ****************************************************************

void GA_Individual::mutate(double pm)
{ size_t g_dim = geno_type.size();
  for( size_t i=0; i < g_dim; i++ )
    if( uniMut.SampleContinuousUnifZeroOne()<pm ) geno_type[i] = ! geno_type[i];
}

















// ****************************************************************
// ****************************************************************

bool operator > (const GA_Individual& a, const GA_Individual& b)
{ return (a.fitness > b.fitness); }

// ****************************************************************

bool operator < (const GA_Individual& a, const GA_Individual& b)
{ return (a.fitness < b.fitness); }

// ****************************************************************

struct Compare_Individual
{
  bool operator() (const GA_Individual& x, const GA_Individual& y)
  { return (x < y); };
};

// ****************************************************************

#endif
