#ifndef GA_SELECTION_H
#define GA_SELECTION_H

#include<cmath>
#include<vector.h>
#include<iostream.h>
#include "./random_generators.h"
#include "./random_init.h"
#include<string>
#include "./bit_string.h"
#include "./ga_individual.h"

using namespace std;

// ****************************************************************

void prop_sel_prob( vector<GA_Individual>& pop )
{ size_t pop_size = pop.size();
  double fitness_sum = 0;
// standard fitness proportionate selection probability
  for( size_t i=0; i < pop_size; i++ ) fitness_sum += pop[i].fitness;
  for( size_t i=0; i < pop_size; i++ ) 
    pop[i].selection_probability = pop[i].fitness/fitness_sum;
}

// ****************************************************************

GA_Individual selection( const vector<GA_Individual>& pop, 
                         const char sel_type='p' )
{ size_t ind, ind1, ind2, pm1; 
  double r, p_sum;
  switch(sel_type)
  { case 'P' : case 'p' :
      r = uniSel.SampleContinuousUnifZeroOne();
      p_sum = pop[0].selection_probability;
      ind = 0;
      while( p_sum < r )
      { ind++;
        p_sum += pop[ind].selection_probability;
      }
      return pop[ind];
    break; 
    case 'T' : case 't' :
      pm1 = pop.size() - 1;
      ind1 = uniSel.SampleDiscreteUnifMinMax(0, pm1);
      ind2 = uniSel.SampleDiscreteUnifMinMax(0, pm1);
      if( pop[ind1] > pop[ind2] ) return pop[ind1];
      else return pop[ind2];
    break;
    default : 
      cout << " Wrong selection type: " 
           << sel_type << "  -> Stop" << endl;
      exit(-1);
  }
}

//****************************************************************

#endif
